unit main;

interface


uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Menus, StdCtrls, nactixml, ExtCtrls;

type
  Tmainform = class(TForm)
    MainMenu: TMainMenu;
    Mapa1: TMenuItem;
    Nacist1: TMenuItem;
    Cesty1: TMenuItem;
    Zborazit1: TMenuItem;
    Mesta1: TMenuItem;
    Opendialog: TOpenDialog;
    mapka: TImage;
    Spojezjednohomesta1: TMenuItem;
    Spojmezi2mamesty1: TMenuItem;
    D1: TMenuItem;
    procedure Button1Click(Sender: TObject);
    procedure Nacist1Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure Zborazit1Click(Sender: TObject);
    procedure Spojezjednohomesta1Click(Sender: TObject);
    procedure Spojmezi2mamesty1Click(Sender: TObject);
    procedure D1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  mainform: Tmainform;
  pomer:real;
  startx, starty:integer;
procedure nakreslito;
procedure drawcesta2(x1,y1,x2,y2:integer);
implementation

uses mestof, trasa;

{$R *.dfm}

procedure Tmainform.Button1Click(Sender: TObject);
begin
 loadlist('R:\mapa.xml');
 nactimesta;
 nacticesty;
 nactispotreby;
 sleep(10);
end;

procedure zpracujmapu;
var i:integer;maxx:integer;
begin
 startx:=0;
 starty:=0;
 maxx:=0;
 for i:=0 to high(mesta) do
 with mesta[i] do
 begin
  if x<startx then startx:=x;
  if y<starty then starty:=y;
  if x>maxx then maxx:=x;
 end;
 dec(startx,20);
 dec(starty,100);
 pomer:=(startx+mainform.mapka.Width-50)/maxx;
end;

procedure drawmesto(x,y:integer;nazev:string);
begin
 with mainform.mapka do
 begin
  canvas.pen.Color:=clblack;
  canvas.pen.Width:=4;
  canvas.MoveTo(x,y);
  canvas.LineTo(x,y);
  canvas.Font.Size:=5;
  canvas.TextOut(x,y-10,nazev);
 end;
end;

procedure drawcesta(x1,y1,x2,y2:integer;v:real);
begin
with mainform.mapka do
 begin
  canvas.pen.Color:=11+(150-trunc(v))*11;
  canvas.pen.Width:=1;
  canvas.MoveTo(x1,y1);
  canvas.LineTo(x2,y2);
 end;
end;

procedure drawcesta2(x1,y1,x2,y2:integer);
begin
with mainform.mapka do
 begin
  canvas.pen.Color:=clblue;
  canvas.pen.Width:=1;
  canvas.MoveTo(x1,y1);
  canvas.LineTo(x2,y2);
 end;
end;

procedure nakreslito;
var i:integer;x1,y1,x2,y2:integer;
begin
 zpracujmapu;
 with mainform.mapka do
 begin
  canvas.Brush.Color:=clwhite;
  canvas.Rectangle(0,0,width,height);
  for i:=0 to high(mesta) do
  with mesta[i] do
    drawmesto(-startx+trunc(x*pomer),-starty+trunc(y*pomer),nazev);
  if mainform.Zborazit1.Checked then
  for i:=0 to high(cesty) do
  with cesty[i] do
  begin
    with mesta[odkud] do
    begin
     x1:=x;
     y1:=y;
    end;

    with mesta[kam] do
    begin
     x2:=x;
     y2:=y;
    end;

    drawcesta(-startx+trunc(x1*pomer),-starty+trunc(y1*pomer),-startx+trunc(x2*pomer),-starty+trunc(y2*pomer),rychlost);
  end;
 end;
end;



procedure Tmainform.Nacist1Click(Sender: TObject);
begin
 if opendialog.Execute then
 begin
  loadlist(opendialog.Filename);
  nactimesta;
  nacticesty;
  nactispotreby;
  fillcs;
  nakreslito;

 end;
end;

procedure Tmainform.FormShow(Sender: TObject);
begin
 Nacist1Click(nil);
end;

procedure Tmainform.Zborazit1Click(Sender: TObject);
begin
 zborazit1.Checked:=not zborazit1.Checked;
 nakreslito;
end;

procedure Tmainform.Spojezjednohomesta1Click(Sender: TObject);
begin
 mestoform.showmodal;
end;

procedure Tmainform.Spojmezi2mamesty1Click(Sender: TObject);
begin
 trasaform.showmodal;
end;

procedure Tmainform.D1Click(Sender: TObject);
begin
 showmessage(inttostr(findmesto('Uhersk Hradit')));
end;

end.
