unit trasa;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, nactixml, trasaunit, main, ulozxml;

type
  Ttrasaform = class(TForm)
    box_od: TComboBox;
    box_do: TComboBox;
    box_krit: TComboBox;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Button1: TButton;
    Memo: TMemo;
    Button2: TButton;
    SaveDialog: TSaveDialog;
    procedure FormShow(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  trasaform: Ttrasaform;

implementation

uses mestof;

{$R *.dfm}

procedure fillmbox;
var i:integer;
begin
 with trasaform do
 begin
  for i:=0 to high(mesta) do
  begin
   box_od.Items.Add(mesta[i].nazev);
   box_do.Items.Add(mesta[i].nazev);
  end;
  box_od.ItemIndex:=0;
  box_do.ItemIndex:=1;
 end;
end;

procedure Ttrasaform.FormShow(Sender: TObject);
begin
 fillmbox;
end;

procedure zvyrazni;
var lm,i,c:integer;x1,x2,y1,y2:integer;
begin
 lm:=best[0];
 for i:=1 to high(best) do
 begin
    with mesta[lm] do
    begin
     x1:=x;
     y1:=y;
    end;

    with mesta[best[i]] do
    begin
     x2:=x;
     y2:=y;
    end;

  drawcesta2(-startx+trunc(x1*pomer),-starty+trunc(y1*pomer),-startx+trunc(x2*pomer),-starty+trunc(y2*pomer));
  lm:=best[i];
 end;
end;

procedure Ttrasaform.Button1Click(Sender: TObject);
var i:integer;
begin
 memo.Clear;
 nakreslito;
 najditrasu(findmesto(box_od.Text),findmesto(box_do.Text),box_krit.ItemIndex+1);
 if length(best)<>0 then
  for i:=0 to high(best) do
   memo.Lines.Add(mesta[best[i]].nazev);
 zvyrazni;
end;

procedure Ttrasaform.Button2Click(Sender: TObject);
begin
 if savedialog.Execute then
  saveit(best,savedialog.FileName);
end;

end.
